//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"

//#include "#_lib_FFT.mq4"
#import "#_lib_FFT.ex4"
void fastcosinetransform(double& a[], int tnn, bool inversefct);
#import

//#property indicator_chart_window
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Orange
#property indicator_color3 Yellow
#property indicator_color4 Chartreuse
#property indicator_color5 Aqua
#property indicator_color6 Blue
#property indicator_color7 BlueViolet
#property indicator_color8 Coral
//---- buffers
double SpecktrBuffer1[];
double SpecktrBuffer2[];
double SpecktrBuffer3[];
double SpecktrBuffer4[];
double SpecktrBuffer5[];
double SpecktrBuffer6[];
double SpecktrBuffer7[];
double SpecktrBuffer8[];
//---
double n=7; //  
int M,tnn1;
double aa[],bb[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,SpecktrBuffer1);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,SpecktrBuffer2);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,SpecktrBuffer3);
SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(3,SpecktrBuffer4);
SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(4,SpecktrBuffer5);
SetIndexStyle(5,DRAW_LINE);
SetIndexBuffer(5,SpecktrBuffer6);
SetIndexStyle(6,DRAW_LINE);
SetIndexBuffer(6,SpecktrBuffer7);
SetIndexStyle(7,DRAW_LINE);
SetIndexBuffer(7,SpecktrBuffer8);
//---
 tnn1=MathPow(2,n);
 M=ArrayResize(aa,tnn1+1);
 ArrayResize(bb,tnn1+1);
 //---
 
 //Comment( "M= ",M);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   counted_bars=100;
   double m;
   for(int i=M-1; i>=1; i--)
   {
      //aa[i]=iOpen(NULL,0,i);
      //aa[i]=Close[i]-Close[i+1];
      //aa[i]=Open[i+1]-Close[i];
      aa[i]=MathLog(Close[i]/Close[i+1]);
      //aa[i]=MathLog(Close[i]/Open[i+1]);
   }
  // Normal2(aa,m);
   fastcosinetransform(aa, tnn1, false);
   //---
   aa[0]=0;
   //---
   int N=ArraySize(aa);
   //---
   ArrayCopy(bb,aa);
   //---
   int Sn;
   Sn=1;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(0,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer1[i]=aa[i];
   }
   //---
   ArrayCopy(aa,bb);
   Sn=2;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(1,Bars-N);
   //---

   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer2[i]=aa[i];
   }
   //----
   //---
   ArrayCopy(aa,bb);
   
   Sn=3;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(2,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer3[i]=aa[i];
   }
   //----
   //---
   ArrayCopy(aa,bb);
   
   Sn=4;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(3,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer4[i]=aa[i];
   }
   //----
   //---
   ArrayCopy(aa,bb);
   Sn=5;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(4,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer5[i]=aa[i];
   }
   //----
   //---
   ArrayCopy(aa,bb);
   Sn=6;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(5,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer6[i]=aa[i];
   }
   //----
   //---
   ArrayCopy(aa,bb);
   Sn=7;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(6,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer7[i]=aa[i];
   }
   //----
   //---
   ArrayCopy(aa,bb);
   Sn=8;
   for(i=1; i<=N-1; i++)
   {
     if(i!=Sn) aa[i]=0;
   }
   //---
   fastcosinetransform(aa, tnn1, true);
   //---
   SetIndexDrawBegin(7,Bars-N);
   //---
   for( i=N-1; i>=0; i--)
   {
      SpecktrBuffer8[i]=aa[i];
   }
   //----

   return(0);
  }
//+------------------------------------------------------------------+
/*/
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void Normal2(double& a[],double& sum_sqrt)
{
   int n=ArraySize(a);
   sum_sqrt=0;
   for(int i=0; i<=n-1; i++)
   {
      sum_sqrt+=MathPow(a[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   //---
   if (sum_sqrt!=0)
   {
     for( i=0; i<=n-1; i++)
     {
       a[i]=a[i]/sum_sqrt;
     }
   }
   //---

   return;
}
//+------------------------------------------------------------------+
*/